local mod = ...



-- mod:registerAssetId("models/Terrain1.fbx/Materials/Material.Water", "MATERIAL_TERRAIN_WATER")
-- mod:override({
-- 	Id = "MATERIAL_TERRAIN_WATER",
-- 	HasAlphaTest = true
-- })



_countHill = 12
_countCliff = 5
-- _countCave = 1
-- _countPlateau = 1
-- _countWater = 1



function registerTerrain(_name)

	mod:registerAssetId("models/Terrain1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Terrain1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrain1.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		}
	})

end



-- function registerWater(_name)

-- 	mod:registerAssetId("models/Terrain1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
-- 	mod:registerPrefabComponent("models/Terrain1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
-- 	mod:configurePrefabFlagList("models/Terrain1.fbx/Prefab/" .. _name, { "WATER" })

-- 	mod:register({
-- 		DataType = "BUILDING_PART",
-- 		Id = "BUILDING_PART_TERRAIN_" .. _name,
-- 		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
-- 		Category = "CORE", 
-- 		ConstructorData = {
-- 			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
-- 		}
-- 	})

-- end



for i= 1, _countHill do
	registerTerrain("HILL" .. i)
end

for i= 1, _countCliff do
	registerTerrain("CLIFF" .. i)
end

-- for i= 1, _countCave do
-- 	registerTerrain("CAVE" .. i)
-- end

-- for i= 1, _countPlateau do
-- 	registerTerrain("PLATEAU" .. i)
-- end

-- for i= 1, _countPlateau do
-- 	registerWater("WATER" .. i)
-- end




-- Building: Terrain -------------------------------------------------------------------------------------

mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_TERRAIN",
	Name = "BUILDING_TERRAIN_NAME",
	Description = "BUILDING_TERRAIN_DESC",
	BuildingType = "DECORATION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_TERRAIN1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_HILL1",
				"BUILDING_PART_TERRAIN_HILL2",
				"BUILDING_PART_TERRAIN_HILL3",
				"BUILDING_PART_TERRAIN_HILL4",
				"BUILDING_PART_TERRAIN_HILL5",
				"BUILDING_PART_TERRAIN_HILL6",
				"BUILDING_PART_TERRAIN_HILL7",
				"BUILDING_PART_TERRAIN_HILL8",
				"BUILDING_PART_TERRAIN_HILL9",
				"BUILDING_PART_TERRAIN_HILL10",
				"BUILDING_PART_TERRAIN_HILL11",
				"BUILDING_PART_TERRAIN_HILL12",
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_CLIFF1",
				"BUILDING_PART_TERRAIN_CLIFF2",
				"BUILDING_PART_TERRAIN_CLIFF3",
				"BUILDING_PART_TERRAIN_CLIFF4",
				"BUILDING_PART_TERRAIN_CLIFF5",
			}
		},
		-- {
		-- 	Name = "BUILDING_SET_TERRAIN3_NAME",
		-- 	BuildingPartList = { 
		-- 		"BUILDING_PART_TERRAIN_CAVE1",
		-- 	}
		-- },
		-- {
		-- 	Name = "BUILDING_SET_TERRAIN4_NAME",
		-- 	BuildingPartList = { 
		-- 		"BUILDING_PART_TERRAIN_PLATEAU1",
		-- 	}
		-- },
		-- {
		-- 	Name = "BUILDING_SET_TERRAIN5_NAME",
		-- 	BuildingPartList = { 
		-- 		"BUILDING_PART_TERRAIN_WATER1",
		-- 	}
		-- },
	},	
	RequiredPartList = {
	},
	IsEditable = true	
})


